import { callWorkerFunction } from './WorkerFunction';

async function onmessage(ev: MessageEvent<{ funcName: string, params: any[] }>)
{
    const start = Date.now();

    const { funcName, params } = ev.data;

    // 獲取結果
    const result = await callWorkerFunction(funcName as never, params as never);

    // 計算消耗
    const cost = Date.now() - start;

    postMessage({ result, cost });
}

export const worker = {
    get onmessage()
    {
        return globalThis.onmessage;
    },
    set onmessage(v)
    {
        globalThis.onmessage = v;
    }
};
worker.onmessage = onmessage;
